Use mrr-daily test sets for mrr-weekly jobs
[csit.git] / resources / libraries / bash / function / common.sh
1 # Copyright (c) 2020 Cisco and/or its affiliates.
2 # Copyright (c) 2020 PANTHEON.tech and/or its affiliates.
3 # Licensed under the Apache License, Version 2.0 (the "License");
4 # you may not use this file except in compliance with the License.
5 # You may obtain a copy of the License at:
6 #
7 #     http://www.apache.org/licenses/LICENSE-2.0
8 #
9 # Unless required by applicable law or agreed to in writing, software
10 # distributed under the License is distributed on an "AS IS" BASIS,
11 # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
12 # See the License for the specific language governing permissions and
13 # limitations under the License.
14
15 set -exuo pipefail
16
17 # This library defines functions used by multiple entry scripts.
18 # Keep functions ordered alphabetically, please.
19
20 # TODO: Add a link to bash style guide.
21 # TODO: Consider putting every die into a {} block,
22 #   the code might become more readable (but longer).
23
24
25 function activate_docker_topology () {
26
27     # Create virtual vpp-device topology. Output of the function is topology
28     # file describing created environment saved to a file.
29     #
30     # Variables read:
31     # - BASH_FUNCTION_DIR - Path to existing directory this file is located in.
32     # - TOPOLOGIES - Available topologies.
33     # - NODENESS - Node multiplicity of desired testbed.
34     # - FLAVOR - Node flavor string, usually describing the processor.
35     # - IMAGE_VER_FILE - Name of file that contains the image version.
36     # - CSIT_DIR - Directory where ${IMAGE_VER_FILE} is located.
37     # Variables set:
38     # - WORKING_TOPOLOGY - Path to topology file.
39
40     set -exuo pipefail
41
42     source "${BASH_FUNCTION_DIR}/device.sh" || {
43         die "Source failed!"
44     }
45
46     device_image="$(< ${CSIT_DIR}/${IMAGE_VER_FILE})"
47     case_text="${NODENESS}_${FLAVOR}"
48     case "${case_text}" in
49         "1n_skx" | "1n_tx2")
50             # We execute reservation over csit-shim-dcr (ssh) which runs sourced
51             # script's functions. Env variables are read from ssh output
52             # back to localhost for further processing.
53             hostname=$(grep search /etc/resolv.conf | cut -d' ' -f3) || die
54             ssh="ssh root@${hostname} -p 6022"
55             run="activate_wrapper ${NODENESS} ${FLAVOR} ${device_image}"
56             # backtics to avoid https://midnight-commander.org/ticket/2142
57             env_vars=`${ssh} "$(declare -f); ${run}"` || {
58                 die "Topology reservation via shim-dcr failed!"
59             }
60             set -a
61             source <(echo "$env_vars" | grep -v /usr/bin/docker) || {
62                 die "Source failed!"
63             }
64             set +a
65             ;;
66         "1n_vbox")
67             # We execute reservation on localhost. Sourced script automatially
68             # sets environment variables for further processing.
69             activate_wrapper "${NODENESS}" "${FLAVOR}" "${device_image}" || die
70             ;;
71         *)
72             die "Unknown specification: ${case_text}!"
73     esac
74
75     trap 'deactivate_docker_topology' EXIT || {
76          die "Trap attempt failed, please cleanup manually. Aborting!"
77     }
78
79     # Replace all variables in template with those in environment.
80     source <(echo 'cat <<EOF >topo.yml'; cat ${TOPOLOGIES[0]}; echo EOF;) || {
81         die "Topology file create failed!"
82     }
83
84     WORKING_TOPOLOGY="/tmp/topology.yaml"
85     mv topo.yml "${WORKING_TOPOLOGY}" || {
86         die "Topology move failed!"
87     }
88     cat ${WORKING_TOPOLOGY} | grep -v password || {
89         die "Topology read failed!"
90     }
91 }
92
93
94 function activate_virtualenv () {
95
96     # Update virtualenv pip package, delete and create virtualenv directory,
97     # activate the virtualenv, install requirements, set PYTHONPATH.
98
99     # Arguments:
100     # - ${1} - Path to existing directory for creating virtualenv in.
101     #          If missing or empty, ${CSIT_DIR} is used.
102     # - ${2} - Path to requirements file, ${CSIT_DIR}/requirements.txt if empty.
103     # Variables read:
104     # - CSIT_DIR - Path to existing root of local CSIT git repository.
105     # Variables exported:
106     # - PYTHONPATH - CSIT_DIR, as CSIT Python scripts usually need this.
107     # Functions called:
108     # - die - Print to stderr and exit.
109
110     set -exuo pipefail
111
112     root_path="${1-$CSIT_DIR}"
113     env_dir="${root_path}/env"
114     req_path=${2-$CSIT_DIR/requirements.txt}
115     rm -rf "${env_dir}" || die "Failed to clean previous virtualenv."
116     pip install --upgrade virtualenv || {
117         die "Virtualenv package install failed."
118     }
119     virtualenv "${env_dir}" || {
120         die "Virtualenv creation failed."
121     }
122     set +u
123     source "${env_dir}/bin/activate" || die "Virtualenv activation failed."
124     set -u
125     pip install --upgrade -r "${req_path}" || {
126         die "Requirements installation failed."
127     }
128     # Most CSIT Python scripts assume PYTHONPATH is set and exported.
129     export PYTHONPATH="${CSIT_DIR}" || die "Export failed."
130 }
131
132
133 function archive_tests () {
134
135     # Create .tar.xz of generated/tests for archiving.
136     # To be run after generate_tests, kept separate to offer more flexibility.
137
138     # Directory read:
139     # - ${GENERATED_DIR}/tests - Tree of executed suites to archive.
140     # File rewriten:
141     # - ${ARCHIVE_DIR}/tests.tar.xz - Archive of generated tests.
142
143     set -exuo pipefail
144
145     tar c "${GENERATED_DIR}/tests" | xz -9e > "${ARCHIVE_DIR}/tests.tar.xz" || {
146         die "Error creating archive of generated tests."
147     }
148 }
149
150
151 function check_download_dir () {
152
153     # Fail if there are no files visible in ${DOWNLOAD_DIR}.
154     #
155     # Variables read:
156     # - DOWNLOAD_DIR - Path to directory pybot takes the build to test from.
157     # Directories read:
158     # - ${DOWNLOAD_DIR} - Has to be non-empty to proceed.
159     # Functions called:
160     # - die - Print to stderr and exit.
161
162     set -exuo pipefail
163
164     if [[ ! "$(ls -A "${DOWNLOAD_DIR}")" ]]; then
165         die "No artifacts downloaded!"
166     fi
167 }
168
169
170 function check_prerequisites () {
171
172     # Fail if prerequisites are not met.
173     #
174     # Functions called:
175     # - installed - Check if application is installed/present in system.
176     # - die - Print to stderr and exit.
177
178     set -exuo pipefail
179
180     if ! installed sshpass; then
181         die "Please install sshpass before continue!"
182     fi
183 }
184
185 function cleanup_topo () {
186
187     # Variables read:
188     # - WORKING_TOPOLOGY - Path to topology yaml file of the reserved testbed.
189     # - PYTHON_SCRIPTS_DIR - Path to directory holding the reservation script.
190
191     set -exuo pipefail
192
193     python "${PYTHON_SCRIPTS_DIR}/topo_cleanup.py" -t "${WORKING_TOPOLOGY}"
194     # Not using "|| die" as some callers might want to ignore errors,
195     # e.g. in teardowns, such as unreserve.
196 }
197
198
199 function common_dirs () {
200
201     # Set global variables, create some directories (without touching content).
202
203     # Variables set:
204     # - BASH_FUNCTION_DIR - Path to existing directory this file is located in.
205     # - CSIT_DIR - Path to existing root of local CSIT git repository.
206     # - TOPOLOGIES_DIR - Path to existing directory with available tpologies.
207     # - RESOURCES_DIR - Path to existing CSIT subdirectory "resources".
208     # - TOOLS_DIR - Path to existing resources subdirectory "tools".
209     # - PYTHON_SCRIPTS_DIR - Path to existing tools subdirectory "scripts".
210     # - ARCHIVE_DIR - Path to created CSIT subdirectory "archive".
211     # - DOWNLOAD_DIR - Path to created CSIT subdirectory "download_dir".
212     # - GENERATED_DIR - Path to created CSIT subdirectory "generated".
213     # Directories created if not present:
214     # ARCHIVE_DIR, DOWNLOAD_DIR, GENERATED_DIR.
215     # Functions called:
216     # - die - Print to stderr and exit.
217
218     set -exuo pipefail
219
220     this_file=$(readlink -e "${BASH_SOURCE[0]}") || {
221         die "Some error during locating of this source file."
222     }
223     BASH_FUNCTION_DIR=$(dirname "${this_file}") || {
224         die "Some error during dirname call."
225     }
226     # Current working directory could be in a different repo, e.g. VPP.
227     pushd "${BASH_FUNCTION_DIR}" || die "Pushd failed"
228     relative_csit_dir=$(git rev-parse --show-toplevel) || {
229         die "Git rev-parse failed."
230     }
231     CSIT_DIR=$(readlink -e "${relative_csit_dir}") || die "Readlink failed."
232     popd || die "Popd failed."
233     TOPOLOGIES_DIR=$(readlink -e "${CSIT_DIR}/topologies/available") || {
234         die "Readlink failed."
235     }
236     RESOURCES_DIR=$(readlink -e "${CSIT_DIR}/resources") || {
237         die "Readlink failed."
238     }
239     TOOLS_DIR=$(readlink -e "${RESOURCES_DIR}/tools") || {
240         die "Readlink failed."
241     }
242     PYTHON_SCRIPTS_DIR=$(readlink -e "${TOOLS_DIR}/scripts") || {
243         die "Readlink failed."
244     }
245
246     ARCHIVE_DIR=$(readlink -f "${CSIT_DIR}/archive") || {
247         die "Readlink failed."
248     }
249     mkdir -p "${ARCHIVE_DIR}" || die "Mkdir failed."
250     DOWNLOAD_DIR=$(readlink -f "${CSIT_DIR}/download_dir") || {
251         die "Readlink failed."
252     }
253     mkdir -p "${DOWNLOAD_DIR}" || die "Mkdir failed."
254     GENERATED_DIR=$(readlink -f "${CSIT_DIR}/generated") || {
255         die "Readlink failed."
256     }
257     mkdir -p "${GENERATED_DIR}" || die "Mkdir failed."
258 }
259
260
261 function compose_pybot_arguments () {
262
263     # Variables read:
264     # - WORKING_TOPOLOGY - Path to topology yaml file of the reserved testbed.
265     # - DUT - CSIT test/ subdirectory, set while processing tags.
266     # - TAGS - Array variable holding selected tag boolean expressions.
267     # - TOPOLOGIES_TAGS - Tag boolean expression filtering tests for topology.
268     # - TEST_CODE - The test selection string from environment or argument.
269     # Variables set:
270     # - PYBOT_ARGS - String holding part of all arguments for pybot.
271     # - EXPANDED_TAGS - Array of strings pybot arguments compiled from tags.
272
273     set -exuo pipefail
274
275     # No explicit check needed with "set -u".
276     PYBOT_ARGS=("--loglevel" "TRACE")
277     PYBOT_ARGS+=("--variable" "TOPOLOGY_PATH:${WORKING_TOPOLOGY}")
278
279     case "${TEST_CODE}" in
280         *"device"*)
281             PYBOT_ARGS+=("--suite" "tests.${DUT}.device")
282             ;;
283         *"func"*)
284             PYBOT_ARGS+=("--suite" "tests.${DUT}.func")
285             ;;
286         *"perf"*)
287             PYBOT_ARGS+=("--suite" "tests.${DUT}.perf")
288             ;;
289         *)
290             die "Unknown specification: ${TEST_CODE}"
291     esac
292
293     EXPANDED_TAGS=()
294     for tag in "${TAGS[@]}"; do
295         if [[ ${tag} == "!"* ]]; then
296             EXPANDED_TAGS+=("--exclude" "${tag#$"!"}")
297         else
298             EXPANDED_TAGS+=("--include" "${TOPOLOGIES_TAGS}AND${tag}")
299         fi
300     done
301 }
302
303
304 function copy_archives () {
305
306     # Create additional archive if workspace variable is set.
307     # This way if script is running in jenkins all will be
308     # automatically archived to logs.fd.io.
309     #
310     # Variables read:
311     # - WORKSPACE - Jenkins workspace, copy only if the value is not empty.
312     #   Can be unset, then it speeds up manual testing.
313     # - ARCHIVE_DIR - Path to directory with content to be copied.
314     # Directories updated:
315     # - ${WORKSPACE}/archives/ - Created if does not exist.
316     #   Content of ${ARCHIVE_DIR}/ is copied here.
317     # Functions called:
318     # - die - Print to stderr and exit.
319
320     set -exuo pipefail
321
322     if [[ -n "${WORKSPACE-}" ]]; then
323         mkdir -p "${WORKSPACE}/archives/" || die "Archives dir create failed."
324         cp -rf "${ARCHIVE_DIR}"/* "${WORKSPACE}/archives" || die "Copy failed."
325     fi
326 }
327
328
329 function deactivate_docker_topology () {
330
331     # Deactivate virtual vpp-device topology by removing containers.
332     #
333     # Variables read:
334     # - NODENESS - Node multiplicity of desired testbed.
335     # - FLAVOR - Node flavor string, usually describing the processor.
336
337     set -exuo pipefail
338
339     case_text="${NODENESS}_${FLAVOR}"
340     case "${case_text}" in
341         "1n_skx" | "1n_tx2")
342             hostname=$(grep search /etc/resolv.conf | cut -d' ' -f3) || die
343             ssh="ssh root@${hostname} -p 6022"
344             env_vars=$(env | grep CSIT_ | tr '\n' ' ' ) || die
345             ${ssh} "$(declare -f); deactivate_wrapper ${env_vars}" || {
346                 die "Topology cleanup via shim-dcr failed!"
347             }
348             ;;
349         "1n_vbox")
350             enter_mutex || die
351             clean_environment || {
352                 die "Topology cleanup locally failed!"
353             }
354             exit_mutex || die
355             ;;
356         *)
357             die "Unknown specification: ${case_text}!"
358     esac
359 }
360
361
362 function die () {
363
364     # Print the message to standard error end exit with error code specified
365     # by the second argument.
366     #
367     # Hardcoded values:
368     # - The default error message.
369     # Arguments:
370     # - ${1} - The whole error message, be sure to quote. Optional
371     # - ${2} - the code to exit with, default: 1.
372
373     set -x
374     set +eu
375     warn "${1:-Unspecified run-time error occurred!}"
376     exit "${2:-1}"
377 }
378
379
380 function die_on_pybot_error () {
381
382     # Source this fragment if you want to abort on any failed test case.
383     #
384     # Variables read:
385     # - PYBOT_EXIT_STATUS - Set by a pybot running fragment.
386     # Functions called:
387     # - die - Print to stderr and exit.
388
389     set -exuo pipefail
390
391     if [[ "${PYBOT_EXIT_STATUS}" != "0" ]]; then
392         die "Test failures are present!" "${PYBOT_EXIT_STATUS}"
393     fi
394 }
395
396
397 function generate_tests () {
398
399     # Populate ${GENERATED_DIR}/tests based on ${CSIT_DIR}/tests/.
400     # Any previously existing content of ${GENERATED_DIR}/tests is wiped before.
401     # The generation is done by executing any *.py executable
402     # within any subdirectory after copying.
403
404     # This is a separate function, because this code is called
405     # both by autogen checker and entries calling run_pybot.
406
407     # Directories read:
408     # - ${CSIT_DIR}/tests - Used as templates for the generated tests.
409     # Directories replaced:
410     # - ${GENERATED_DIR}/tests - Overwritten by the generated tests.
411
412     set -exuo pipefail
413
414     rm -rf "${GENERATED_DIR}/tests" || die
415     cp -r "${CSIT_DIR}/tests" "${GENERATED_DIR}/tests" || die
416     cmd_line=("find" "${GENERATED_DIR}/tests" "-type" "f")
417     cmd_line+=("-executable" "-name" "*.py")
418     file_list=$("${cmd_line[@]}") || die
419
420     for gen in ${file_list}; do
421         directory="$(dirname "${gen}")" || die
422         filename="$(basename "${gen}")" || die
423         pushd "${directory}" || die
424         ./"${filename}" || die
425         popd || die
426     done
427 }
428
429
430 function get_test_code () {
431
432     # Arguments:
433     # - ${1} - Optional, argument of entry script (or empty as unset).
434     #   Test code value to override job name from environment.
435     # Variables read:
436     # - JOB_NAME - String affecting test selection, default if not argument.
437     # Variables set:
438     # - TEST_CODE - The test selection string from environment or argument.
439     # - NODENESS - Node multiplicity of desired testbed.
440     # - FLAVOR - Node flavor string, usually describing the processor.
441
442     set -exuo pipefail
443
444     TEST_CODE="${1-}" || die "Reading optional argument failed, somehow."
445     if [[ -z "${TEST_CODE}" ]]; then
446         TEST_CODE="${JOB_NAME-}" || die "Reading job name failed, somehow."
447     fi
448
449     case "${TEST_CODE}" in
450         *"1n-vbox"*)
451             NODENESS="1n"
452             FLAVOR="vbox"
453             ;;
454         *"1n-skx"*)
455             NODENESS="1n"
456             FLAVOR="skx"
457             ;;
458        *"1n-tx2"*)
459             NODENESS="1n"
460             FLAVOR="tx2"
461             ;;
462         *"2n-clx"*)
463             NODENESS="2n"
464             FLAVOR="clx"
465             ;;
466         *"2n-skx"*)
467             NODENESS="2n"
468             FLAVOR="skx"
469             ;;
470         *"3n-skx"*)
471             NODENESS="3n"
472             FLAVOR="skx"
473             ;;
474         *"2n-dnv"*)
475             NODENESS="2n"
476             FLAVOR="dnv"
477             ;;
478         *"3n-dnv"*)
479             NODENESS="3n"
480             FLAVOR="dnv"
481             ;;
482         *"3n-tsh"*)
483             NODENESS="3n"
484             FLAVOR="tsh"
485             ;;
486         *)
487             # Fallback to 3-node Haswell by default (backward compatibility)
488             NODENESS="3n"
489             FLAVOR="hsw"
490             ;;
491     esac
492 }
493
494
495 function get_test_tag_string () {
496
497     # Variables read:
498     # - GERRIT_EVENT_TYPE - Event type set by gerrit, can be unset.
499     # - GERRIT_EVENT_COMMENT_TEXT - Comment text, read for "comment-added" type.
500     # - TEST_CODE - The test selection string from environment or argument.
501     # Variables set:
502     # - TEST_TAG_STRING - The string following trigger word in gerrit comment.
503     #   May be empty, not set on event types not adding comment.
504
505     # TODO: ci-management scripts no longer need to perform this.
506
507     set -exuo pipefail
508
509     trigger=""
510     if [[ "${GERRIT_EVENT_TYPE-}" == "comment-added" ]]; then
511         case "${TEST_CODE}" in
512             *"device"*)
513                 # On parsing error, ${trigger} stays empty.
514                 trigger="$(echo "${GERRIT_EVENT_COMMENT_TEXT}" \
515                     | grep -oE '(devicetest$|devicetest[[:space:]].+$)')" \
516                     || true
517                 # Set test tags as string.
518                 TEST_TAG_STRING="${trigger#$"devicetest"}"
519                 ;;
520             *"perf"*)
521                 # On parsing error, ${trigger} stays empty.
522                 comment="${GERRIT_EVENT_COMMENT_TEXT}"
523                 # As "perftest" can be followed by something, we substitute it.
524                 comment="${comment/perftest-2n/perftest}"
525                 comment="${comment/perftest-3n/perftest}"
526                 comment="${comment/perftest-hsw/perftest}"
527                 comment="${comment/perftest-skx/perftest}"
528                 comment="${comment/perftest-dnv/perftest}"
529                 comment="${comment/perftest-tsh/perftest}"
530                 tag_string="$(echo "${comment}" \
531                     | grep -oE '(perftest$|perftest[[:space:]].+$)' || true)"
532                 # Set test tags as string.
533                 TEST_TAG_STRING="${tag_string#$"perftest"}"
534                 ;;
535             *)
536                 die "Unknown specification: ${TEST_CODE}"
537         esac
538     fi
539 }
540
541
542 function installed () {
543
544     # Check if the given utility is installed. Fail if not installed.
545     #
546     # Duplicate of common.sh function, as this file is also used standalone.
547     #
548     # Arguments:
549     # - ${1} - Utility to check.
550     # Returns:
551     # - 0 - If command is installed.
552     # - 1 - If command is not installed.
553
554     set -exuo pipefail
555
556     command -v "${1}"
557 }
558
559
560 function reserve_and_cleanup_testbed () {
561
562     # Reserve physical testbed, perform cleanup, register trap to unreserve.
563     # When cleanup fails, remove from topologies and keep retrying
564     # until all topologies are removed.
565     #
566     # Variables read:
567     # - TOPOLOGIES - Array of paths to topology yaml to attempt reservation on.
568     # - PYTHON_SCRIPTS_DIR - Path to directory holding the reservation script.
569     # - BUILD_TAG - Any string suitable as filename, identifying
570     #   test run executing this function. May be unset.
571     # - BUILD_URL - Any string suitable as URL, identifying
572     #   test run executing this function. May be unset.
573     # Variables set:
574     # - TOPOLOGIES - Array of paths to topologies, with failed cleanups removed.
575     # - WORKING_TOPOLOGY - Path to topology yaml file of the reserved testbed.
576     # Functions called:
577     # - die - Print to stderr and exit.
578     # Traps registered:
579     # - EXIT - Calls cancel_all for ${WORKING_TOPOLOGY}.
580
581     set -exuo pipefail
582
583     while [[ ${TOPOLOGIES[@]} ]]; do
584         for topo in "${TOPOLOGIES[@]}"; do
585             set +e
586             scrpt="${PYTHON_SCRIPTS_DIR}/topo_reservation.py"
587             opts=("-t" "${topo}" "-r" "${BUILD_TAG:-Unknown}")
588             opts+=("-u" "${BUILD_URL:-Unknown}")
589             python "${scrpt}" "${opts[@]}"
590             result="$?"
591             set -e
592             if [[ "${result}" == "0" ]]; then
593                 # Trap unreservation before cleanup check,
594                 # so multiple jobs showing failed cleanup improve chances
595                 # of humans to notice and fix.
596                 WORKING_TOPOLOGY="${topo}"
597                 echo "Reserved: ${WORKING_TOPOLOGY}"
598                 trap "untrap_and_unreserve_testbed" EXIT || {
599                     message="TRAP ATTEMPT AND UNRESERVE FAILED, FIX MANUALLY."
600                     untrap_and_unreserve_testbed "${message}" || {
601                         die "Teardown should have died, not failed."
602                     }
603                     die "Trap attempt failed, unreserve succeeded. Aborting."
604                 }
605                 # Cleanup check.
606                 set +e
607                 cleanup_topo
608                 result="$?"
609                 set -e
610                 if [[ "${result}" == "0" ]]; then
611                     break
612                 fi
613                 warn "Testbed cleanup failed: ${topo}"
614                 untrap_and_unreserve_testbed "Fail of unreserve after cleanup."
615                 # WORKING_TOPOLOGY is now empty again.
616                 # Build new topology array.
617                 #   TOPOLOGIES=("${TOPOLOGIES[@]/$topo}")
618                 # does not really work, see:
619                 # https://stackoverflow.com/questions/16860877/remove-an-element-from-a-bash-array
620                 new_topologies=()
621                 for item in "${TOPOLOGIES[@]}"; do
622                     if [[ "${item}" != "${topo}" ]]; then
623                         new_topologies+=("${item}")
624                     fi
625                 done
626                 TOPOLOGIES=("${new_topologies[@]}")
627                 break
628             fi
629         done
630
631         if [[ -n "${WORKING_TOPOLOGY-}" ]]; then
632             # Exit the infinite while loop if we made a reservation.
633             break
634         fi
635
636         # Wait ~3minutes before next try.
637         sleep_time="$[ ( $RANDOM % 20 ) + 180 ]s" || {
638             die "Sleep time calculation failed."
639         }
640         echo "Sleeping ${sleep_time}"
641         sleep "${sleep_time}" || die "Sleep failed."
642     done
643     if [[ ${TOPOLOGIES[@]} ]]; then
644         echo "Reservation and cleanup successful."
645     else
646         die "Run out of operational testbeds!"
647     fi
648 }
649
650
651 function run_pybot () {
652
653     # Run pybot with options based on input variables. Create output_info.xml
654     #
655     # Variables read:
656     # - CSIT_DIR - Path to existing root of local CSIT git repository.
657     # - ARCHIVE_DIR - Path to store robot result files in.
658     # - PYBOT_ARGS, EXPANDED_TAGS - See compose_pybot_arguments.sh
659     # - GENERATED_DIR - Tests are assumed to be generated under there.
660     # Variables set:
661     # - PYBOT_EXIT_STATUS - Exit status of most recent pybot invocation.
662     # Functions called:
663     # - die - Print to stderr and exit.
664
665     set -exuo pipefail
666
667     all_options=("--outputdir" "${ARCHIVE_DIR}" "${PYBOT_ARGS[@]}")
668     all_options+=("--noncritical" "EXPECTED_FAILING")
669     all_options+=("${EXPANDED_TAGS[@]}")
670
671     pushd "${CSIT_DIR}" || die "Change directory operation failed."
672     set +e
673     pybot "${all_options[@]}" "${GENERATED_DIR}/tests/"
674     PYBOT_EXIT_STATUS="$?"
675     set -e
676
677     # Generate INFO level output_info.xml for post-processing.
678     all_options=("--loglevel" "INFO")
679     all_options+=("--log" "none")
680     all_options+=("--report" "none")
681     all_options+=("--output" "${ARCHIVE_DIR}/output_info.xml")
682     all_options+=("${ARCHIVE_DIR}/output.xml")
683     rebot "${all_options[@]}" || true
684     popd || die "Change directory operation failed."
685 }
686
687
688 function select_arch_os () {
689
690     # Set variables affected by local CPU architecture and operating system.
691     #
692     # Variables set:
693     # - VPP_VER_FILE - Name of file in CSIT dir containing vpp stable version.
694     # - IMAGE_VER_FILE - Name of file in CSIT dir containing the image name.
695     # - PKG_SUFFIX - Suffix of OS package file name, "rpm" or "deb."
696
697     set -exuo pipefail
698
699     os_id=$(grep '^ID=' /etc/os-release | cut -f2- -d= | sed -e 's/\"//g') || {
700         die "Get OS release failed."
701     }
702
703     case "${os_id}" in
704         "ubuntu"*)
705             IMAGE_VER_FILE="VPP_DEVICE_IMAGE_UBUNTU"
706             VPP_VER_FILE="VPP_STABLE_VER_UBUNTU_BIONIC"
707             PKG_SUFFIX="deb"
708             ;;
709         "centos"*)
710             IMAGE_VER_FILE="VPP_DEVICE_IMAGE_CENTOS"
711             VPP_VER_FILE="VPP_STABLE_VER_CENTOS"
712             PKG_SUFFIX="rpm"
713             ;;
714         *)
715             die "Unable to identify distro or os from ${os_id}"
716             ;;
717     esac
718
719     arch=$(uname -m) || {
720         die "Get CPU architecture failed."
721     }
722
723     case "${arch}" in
724         "aarch64")
725             IMAGE_VER_FILE="${IMAGE_VER_FILE}_ARM"
726             ;;
727         *)
728             ;;
729     esac
730 }
731
732
733 function select_tags () {
734
735     # Variables read:
736     # - WORKING_TOPOLOGY - Path to topology yaml file of the reserved testbed.
737     # - TEST_CODE - String affecting test selection, usually jenkins job name.
738     # - TEST_TAG_STRING - String selecting tags, from gerrit comment.
739     #   Can be unset.
740     # - TOPOLOGIES_DIR - Path to existing directory with available tpologies.
741     # - BASH_FUNCTION_DIR - Directory with input files to process.
742     # Variables set:
743     # - TAGS - Array of processed tag boolean expressions.
744
745     set -exuo pipefail
746
747     # NIC SELECTION
748     start_pattern='^  TG:'
749     end_pattern='^ \? \?[A-Za-z0-9]\+:'
750     # Remove the TG section from topology file
751     sed_command="/${start_pattern}/,/${end_pattern}/d"
752     # All topologies DUT NICs
753     available=$(sed "${sed_command}" "${TOPOLOGIES_DIR}"/* \
754                 | grep -hoP "model: \K.*" | sort -u)
755     # Selected topology DUT NICs
756     reserved=$(sed "${sed_command}" "${WORKING_TOPOLOGY}" \
757                | grep -hoP "model: \K.*" | sort -u)
758     # All topologies DUT NICs - Selected topology DUT NICs
759     exclude_nics=($(comm -13 <(echo "${reserved}") <(echo "${available}"))) || {
760         die "Computation of excluded NICs failed."
761     }
762
763     # Select default NIC tag.
764     case "${TEST_CODE}" in
765         *"3n-dnv"* | *"2n-dnv"*)
766             default_nic="nic_intel-x553"
767             ;;
768         *"3n-tsh"*)
769             default_nic="nic_intel-x520-da2"
770             ;;
771         *)
772             default_nic="nic_intel-x710"
773             ;;
774     esac
775
776     sed_nic_sub_cmd="sed s/\${default_nic}/${default_nic}/"
777     # Tag file directory shorthand.
778     tfd="${BASH_FUNCTION_DIR}"
779     case "${TEST_CODE}" in
780         # Select specific performance tests based on jenkins job type variable.
781         *"ndrpdr-weekly"* )
782             readarray -t test_tag_array < "${tfd}/mlr-weekly.txt" || die
783             ;;
784         *"mrr-daily"* )
785             readarray -t test_tag_array <<< $(${sed_nic_sub_cmd} \
786                 ${tfd}/mrr-daily-${FLAVOR}.txt) || die
787             ;;
788         *"mrr-weekly"* )
789             readarray -t test_tag_array <<< $(${sed_nic_sub_cmd} \
790                 ${tfd}/mrr-weekly.txt) || die
791             ;;
792         * )
793             if [[ -z "${TEST_TAG_STRING-}" ]]; then
794                 # If nothing is specified, we will run pre-selected tests by
795                 # following tags.
796                 test_tag_array=("mrrAND${default_nic}AND1cAND64bANDip4base"
797                                 "mrrAND${default_nic}AND1cAND78bANDip6base"
798                                 "mrrAND${default_nic}AND1cAND64bANDl2bdbase"
799                                 "mrrAND${default_nic}AND1cAND64bANDl2xcbase"
800                                 "!dot1q" "!drv_avf")
801             else
802                 # If trigger contains tags, split them into array.
803                 test_tag_array=(${TEST_TAG_STRING//:/ })
804             fi
805             ;;
806     esac
807
808     # Blacklisting certain tags per topology.
809     #
810     # Reasons for blacklisting:
811     # - ipsechw - Blacklisted on testbeds without crypto hardware accelerator.
812     # TODO: Add missing reasons here (if general) or where used (if specific).
813     case "${TEST_CODE}" in
814         *"2n-clx"*)
815             test_tag_array+=("!ipsechw")
816             ;;
817         *"2n-skx"*)
818             test_tag_array+=("!ipsechw")
819             ;;
820         *"3n-skx"*)
821             test_tag_array+=("!ipsechw")
822             # Not enough nic_intel-xxv710 to support double link tests.
823             test_tag_array+=("!3_node_double_link_topoANDnic_intel-xxv710")
824             ;;
825         *"2n-dnv"*)
826             test_tag_array+=("!ipsechw")
827             test_tag_array+=("!memif")
828             test_tag_array+=("!srv6_proxy")
829             test_tag_array+=("!vhost")
830             test_tag_array+=("!vts")
831             test_tag_array+=("!drv_avf")
832             ;;
833         *"3n-dnv"*)
834             test_tag_array+=("!memif")
835             test_tag_array+=("!srv6_proxy")
836             test_tag_array+=("!vhost")
837             test_tag_array+=("!vts")
838             test_tag_array+=("!drv_avf")
839             ;;
840         *"3n-tsh"*)
841             # 3n-tsh only has x520 NICs which don't work with AVF
842             test_tag_array+=("!drv_avf")
843             test_tag_array+=("!ipsechw")
844             ;;
845         *"3n-hsw"*)
846             # TODO: Introduce NOIOMMU version of AVF tests.
847             # TODO: Make (both) AVF tests work on Haswell,
848             # or document why (some of) it is not possible.
849             # https://github.com/FDio/vpp/blob/master/src/plugins/avf/README.md
850             test_tag_array+=("!drv_avf")
851             # All cards have access to QAT. But only one card (xl710)
852             # resides in same NUMA as QAT. Other cards must go over QPI
853             # which we do not want to even run.
854             test_tag_array+=("!ipsechwNOTnic_intel-xl710")
855             ;;
856         *)
857             # Default to 3n-hsw due to compatibility.
858             test_tag_array+=("!drv_avf")
859             test_tag_array+=("!ipsechwNOTnic_intel-xl710")
860             ;;
861     esac
862
863     # We will add excluded NICs.
864     test_tag_array+=("${exclude_nics[@]/#/!NIC_}")
865
866     TAGS=()
867
868     # We will prefix with perftest to prevent running other tests
869     # (e.g. Functional).
870     prefix="perftestAND"
871     set +x
872     if [[ "${TEST_CODE}" == "vpp-"* ]]; then
873         # Automatic prefixing for VPP jobs to limit the NIC used and
874         # traffic evaluation to MRR.
875         if [[ "${TEST_TAG_STRING-}" == *"nic_"* ]]; then
876             prefix="${prefix}mrrAND"
877         else
878             prefix="${prefix}mrrAND${default_nic}AND"
879         fi
880     fi
881     for tag in "${test_tag_array[@]}"; do
882         if [[ "${tag}" == "!"* ]]; then
883             # Exclude tags are not prefixed.
884             TAGS+=("${tag}")
885         elif [[ "${tag}" != "" && "${tag}" != "#"* ]]; then
886             # Empty and comment lines are skipped.
887             # Other lines are normal tags, they are to be prefixed.
888             TAGS+=("${prefix}${tag}")
889         fi
890     done
891     set -x
892 }
893
894
895 function select_topology () {
896
897     # Variables read:
898     # - NODENESS - Node multiplicity of testbed, either "2n" or "3n".
899     # - FLAVOR - Node flavor string, currently either "hsw" or "skx".
900     # - CSIT_DIR - Path to existing root of local CSIT git repository.
901     # - TOPOLOGIES_DIR - Path to existing directory with available topologies.
902     # Variables set:
903     # - TOPOLOGIES - Array of paths to suitable topology yaml files.
904     # - TOPOLOGIES_TAGS - Tag expression selecting tests for the topology.
905     # Functions called:
906     # - die - Print to stderr and exit.
907
908     set -exuo pipefail
909
910     case_text="${NODENESS}_${FLAVOR}"
911     case "${case_text}" in
912         # TODO: Move tags to "# Blacklisting certain tags per topology" section.
913         # TODO: Double link availability depends on NIC used.
914         "1n_vbox")
915             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*vpp_device*.template )
916             TOPOLOGIES_TAGS="2_node_single_link_topo"
917             ;;
918         "1n_skx" | "1n_tx2")
919             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*vpp_device*.template )
920             TOPOLOGIES_TAGS="2_node_single_link_topo"
921             ;;
922         "2n_clx")
923             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*2n_clx*.yaml )
924             TOPOLOGIES_TAGS="2_node_*_link_topo"
925             ;;
926         "2n_skx")
927             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*2n_skx*.yaml )
928             TOPOLOGIES_TAGS="2_node_*_link_topo"
929             ;;
930         "3n_skx")
931             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*3n_skx*.yaml )
932             TOPOLOGIES_TAGS="3_node_*_link_topo"
933             ;;
934         "2n_dnv")
935             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*2n_dnv*.yaml )
936             TOPOLOGIES_TAGS="2_node_single_link_topo"
937             ;;
938         "3n_dnv")
939             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*3n_dnv*.yaml )
940             TOPOLOGIES_TAGS="3_node_single_link_topo"
941             ;;
942         "3n_hsw")
943             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*3n_hsw*.yaml )
944             TOPOLOGIES_TAGS="3_node_single_link_topo"
945             ;;
946         "3n_tsh")
947             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*3n_tsh*.yaml )
948             TOPOLOGIES_TAGS="3_node_single_link_topo"
949             ;;
950         *)
951             # No falling back to 3n_hsw default, that should have been done
952             # by the function which has set NODENESS and FLAVOR.
953             die "Unknown specification: ${case_text}"
954     esac
955
956     if [[ -z "${TOPOLOGIES-}" ]]; then
957         die "No applicable topology found!"
958     fi
959 }
960
961
962 function select_vpp_device_tags () {
963
964     # Variables read:
965     # - TEST_CODE - String affecting test selection, usually jenkins job name.
966     # - TEST_TAG_STRING - String selecting tags, from gerrit comment.
967     #   Can be unset.
968     # Variables set:
969     # - TAGS - Array of processed tag boolean expressions.
970
971     set -exuo pipefail
972
973     case "${TEST_CODE}" in
974         # Select specific device tests based on jenkins job type variable.
975         * )
976             if [[ -z "${TEST_TAG_STRING-}" ]]; then
977                 # If nothing is specified, we will run pre-selected tests by
978                 # following tags. Items of array will be concatenated by OR
979                 # in Robot Framework.
980                 test_tag_array=()
981             else
982                 # If trigger contains tags, split them into array.
983                 test_tag_array=(${TEST_TAG_STRING//:/ })
984             fi
985             ;;
986     esac
987
988     # Blacklisting certain tags per topology.
989     #
990     # Reasons for blacklisting:
991     # - avf - AVF is not possible to run on enic driver of VirtualBox.
992     # - vhost - VirtualBox does not support nesting virtualization on Intel CPU.
993     case "${TEST_CODE}" in
994         *"1n-vbox"*)
995             test_tag_array+=("!avf")
996             test_tag_array+=("!vhost")
997             ;;
998         *)
999             ;;
1000     esac
1001
1002     TAGS=()
1003
1004     # We will prefix with devicetest to prevent running other tests
1005     # (e.g. Functional).
1006     prefix="devicetestAND"
1007     if [[ "${TEST_CODE}" == "vpp-"* ]]; then
1008         # Automatic prefixing for VPP jobs to limit testing.
1009         prefix="${prefix}"
1010     fi
1011     for tag in "${test_tag_array[@]}"; do
1012         if [[ ${tag} == "!"* ]]; then
1013             # Exclude tags are not prefixed.
1014             TAGS+=("${tag}")
1015         else
1016             TAGS+=("${prefix}${tag}")
1017         fi
1018     done
1019 }
1020
1021 function untrap_and_unreserve_testbed () {
1022
1023     # Use this as a trap function to ensure testbed does not remain reserved.
1024     # Perhaps call directly before script exit, to free testbed for other jobs.
1025     # This function is smart enough to avoid multiple unreservations (so safe).
1026     # Topo cleanup is executed (call it best practice), ignoring failures.
1027     #
1028     # Hardcoded values:
1029     # - default message to die with if testbed might remain reserved.
1030     # Arguments:
1031     # - ${1} - Message to die with if unreservation fails. Default hardcoded.
1032     # Variables read (by inner function):
1033     # - WORKING_TOPOLOGY - Path to topology yaml file of the reserved testbed.
1034     # - PYTHON_SCRIPTS_DIR - Path to directory holding Python scripts.
1035     # Variables written:
1036     # - WORKING_TOPOLOGY - Set to empty string on successful unreservation.
1037     # Trap unregistered:
1038     # - EXIT - Failure to untrap is reported, but ignored otherwise.
1039     # Functions called:
1040     # - die - Print to stderr and exit.
1041
1042     set -xo pipefail
1043     set +eu  # We do not want to exit early in a "teardown" function.
1044     trap - EXIT || echo "Trap deactivation failed, continuing anyway."
1045     wt="${WORKING_TOPOLOGY}"  # Just to avoid too long lines.
1046     if [[ -z "${wt-}" ]]; then
1047         set -eu
1048         warn "Testbed looks unreserved already. Trap removal failed before?"
1049     else
1050         cleanup_topo || true
1051         python "${PYTHON_SCRIPTS_DIR}/topo_reservation.py" -c -t "${wt}" || {
1052             die "${1:-FAILED TO UNRESERVE, FIX MANUALLY.}" 2
1053         }
1054         WORKING_TOPOLOGY=""
1055         set -eu
1056     fi
1057 }
1058
1059
1060 function warn () {
1061
1062     # Print the message to standard error.
1063     #
1064     # Arguments:
1065     # - ${@} - The text of the message.
1066
1067     set -exuo pipefail
1068
1069     echo "$@" >&2
1070 }